clear
load blfsegment;
load segmentindex;
trainnum = 500;
starttime = cputime;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for k = 1:10
    % Tanslate the data
    index1            =  segmentindex(k,1:trainnum);
    index2            =  segmentindex(k,1+trainnum:end);
    trainsamples      =  segmentsamples(index1,:);
    testsamples       =  segmentsamples(index2,:);
    [trainsamples,A,B]=  scaletrain(trainsamples);
    testsamples       =  scaletest(testsamples,A,B);
    trainlabels       =  segmentlabels(index1);
    testlabels        =  segmentlabels(index2);
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   calculate the correct rate       
      
    options = optimset('GradObj','on');
    options = optimset(options,'LargeScale','off');
    options = optimset(options,'DerivativeCheck','off');
    options = optimset(options,'Display','iter');
    options = optimset(options,'MaxIter',50);
    options = optimset(options,'TolFun',1e-4);
    options = optimset(options,'TolX',1e-4);
    options = optimset(options,'LineSearchType','cubicpoly');
    
    D = size(trainsamples,2);
    x = log(1/D)*ones(size(trainsamples,2),1);
    [x,fx,c]     = fminunc('mkfdakernel',[x;0*ones(1,1)],options,trainsamples,trainlabels);
    [a,b,loo(k)] = mkfdakernel(x,trainsamples,trainlabels);
    fprintf('%f\n',loo(k));
    result       = mkfdapred(x, trainsamples, trainlabels,testsamples);
    testerror(k) = 1 - mean(result == testlabels);
     
     fprintf('meanerror = %f\n',mean(testerror));
     fprintf('Iteration = %d\n',k);
 end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   print the output
endtime   = cputime;
meanerror = mean(testerror);
stderror  = std(testerror);
fprintf('meanerror = %f\n',meanerror);
fprintf('stderror  = %f\n',stderror);
fprintf('time      = %f\n',endtime-starttime);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%