clear
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % generate data
% D = 20;
% xortrainsamples = 2*rand(200,D)-1;
% xortestsamples  = 2*rand(200,D)-1;
% xortrainlabels  = 2*(xortrainsamples(:,1).*xortrainsamples(:,2) > 0 ) - 1;
% xortestlabels   = 2*(xortestsamples(:,1).*xortestsamples(:,2) > 0) - 1;

% load dataset
load xor
D = size(xortrainsamples,2);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   calculate the correct rate
options = optimset('GradObj','on');
options = optimset(options,'LargeScale','off');
options = optimset(options,'DerivativeCheck','off');
options = optimset(options,'Display','iter');
options = optimset(options,'MaxIter',50);
options = optimset(options,'TolFun',1e-4);
options = optimset(options,'TolX',1e-4);
options = optimset(options,'LineSearchType','cubicpoly');
    
[x fx c]     = fminunc('kfdakernel',[log(1/D)*ones(size(xortrainsamples,2),1);-1],options,...
    xortrainsamples,xortrainlabels);
result       = kfdapred(x, xortrainsamples,xortrainlabels,xortestsamples);
error        = 1 - mean(sign(result) == xortestlabels);
fprintf('%f \n',error);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

scaling = exp(x(1:end-1));
stem(scaling);
xlabel('Scaling factors');
ylabel('Magnitude');

