function K = evalkernel(samples1, samples2, kernel, kernelparam)
% evaluate kernel function

if (size(samples1,2)~=size(samples2,2))
    error('sample1 and sample2 differ in dimensionality!!');
end
[L1, dim] = size(samples1);
[L2, dim] = size(samples2);

switch kernel    
case 'linear'
    K = samples1*samples2'/dim;
case 'rbf'
    a = sum(samples1.*samples1,2);
    b = sum(samples2.*samples2,2);
    dist2 = a*ones(1,L2) + ones(L1,1)*b' - 2*samples1*samples2';
    K = exp(-kernelparam*dist2);
otherwise
    error('Unknown kernel function');
end