function result = mkfdapred(X, samples, labels, testsamples);

% Gaussian kernel
% D+1 parameters

[n, D] = size(samples);   % number of training cases and dimension of samples space
[nn, D] = size(testsamples);       % number of testsamples cases and dimension of samples space
expX = exp(X);              % exponentiate the hyperparameters once and for all

% first, we write out the covariance matrix Q for the training sampless ...

Z = zeros(n,n);                                         % create and zero space
for d = 1:D                                           % non-linear contribution
  Z = Z + expX(d)*(repmat(samples(:,d),1,n)-repmat(samples(:,d)',n,1)).^2;
end
Z = exp(-0.5*Z);
Z = [Z ones(length(labels),1)];
Q = Z'*Z;
Q = Q + expX(D+1)*eye(n+1) + 1e-4*eye(n+1);

% ... then we compute the covariance between training and testsamples sampless ...
A = zeros(nn,n);                                       % create and zero space
for d = 1:D
  A = A + expX(d)*(repmat(testsamples(:,d),1,n)-repmat(samples(:,d)',nn,1)).^2;
end
A = exp(-0.5*A);
A = [A ones(size(testsamples,1),1)];

% Now, write out the desired terms
mlabels = labels;
labelsnum = unique(labels);
c = length(labelsnum);
for i = 1:c
    tempindex1 = find(labels == labelsnum(i));
    tempindex2 = 1:n;
    tempindex2(tempindex1) = [];
    mlabels(tempindex1,1) = -1;
    mlabels(tempindex2,1) = 1;
    subresult = A*(Q\(Z'*mlabels));
    cmatrix(:,i) = subresult;
end
[mini,result] = min(cmatrix,[],2);


